/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "ebook.override"
#include <time.h>
#include <Python.h>
#include "pygobject.h"

#include "override_common.h"

#include "evo-ebook-environment.h"
#include "evo-contact.h"
#include "evo-addressbook.h"
#include "ebook-enums.h"

static PyObject *
_helper_wrap_glist_of_evo_locations(GList *locations)
{
	PyObject *result;
	int i;

	if ((result = PyList_New (g_list_length (locations))) == NULL)
		return NULL;

	i = 0;
	for (; locations != NULL; locations = locations->next) {
		evo_location_t *path = (evo_location_t *) locations->data;
		PyObject *t = PyTuple_New (2);
		if (path->name == NULL) {
			Py_INCREF (Py_None);
			PyTuple_SET_ITEM (t, 0, Py_None);
		} else {
			PyTuple_SET_ITEM (t, 0, PyString_FromString(path->name));
		}
		
		if (path->uri == NULL) {
			Py_INCREF (Py_None);
			PyTuple_SET_ITEM (t, 1, Py_None);
		} else {
			PyTuple_SET_ITEM (t, 1, PyString_FromString(path->uri));
		}

		PyList_SET_ITEM (result, i, t);
		i++;
	}
	return result;
}

/* EBookQuery */

typedef struct {
	PyObject_HEAD
	EBookQuery *query;
} PyEBookQuery;

/* Forward function declarations */
static PyObject *pyebook_query_new(EBookQuery *query);
static void pyebook_query_dealloc(PyEBookQuery *self);
static PyObject *pyebook_query_str(PyEBookQuery *self);

static PyObject *pyebook_query_from_string(PyEBookQuery *self,
                                           PyObject *args,
                                           PyObject *kwargs);
static PyObject *pyebook_query_field_exists(PyEBookQuery *self,
                                            PyObject *args,
                                            PyObject *kwargs);
static PyObject *pyebook_query_vcard_field_exists(PyEBookQuery *self,
                                                  PyObject *args,
                                                  PyObject *kwargs);
static PyObject *pyebook_query_field_test(PyEBookQuery *self,
                                          PyObject *args,
                                          PyObject *kwargs);
static PyObject *pyebook_query_any_field_contains(PyEBookQuery *self,
                                                  PyObject *args,
                                                  PyObject *kwargs);
static PyObject *pyebook_query_and(PyEBookQuery *self,
                                   PyObject *args,
                                   PyObject *kwargs);
static PyObject *pyebook_query_or(PyEBookQuery *self,
                                   PyObject *args,
                                   PyObject *kwargs);
static PyObject *pyebook_query_not(PyEBookQuery *self,
                                   PyObject *args);
static PyObject *pyebook_query_copy(PyEBookQuery *self,
                                    PyObject *args);

static PyMethodDef PyEBookQuery_methods[] = {
    {"from_string", (PyCFunctionWithKeywords)pyebook_query_from_string,
        METH_KEYWORDS | METH_VARARGS | METH_CLASS,
        "Creates a new query from a string."},
    {"field_exists", (PyCFunctionWithKeywords)pyebook_query_field_exists,
        METH_KEYWORDS | METH_VARARGS | METH_CLASS,
        "Replaces this query with a new query to check if the given \
        field exists"},
    {"vcard_field_exists",
        (PyCFunctionWithKeywords)pyebook_query_vcard_field_exists,
        METH_KEYWORDS | METH_VARARGS | METH_CLASS,
        "Replaces this query with a new query to check if the given \
        vcard field exists"},
    {"field_test", (PyCFunctionWithKeywords)pyebook_query_field_test,
        METH_KEYWORDS | METH_VARARGS | METH_CLASS,
        "Replaces this query with a new query with a given test."},
    {"any_field_contains",
        (PyCFunctionWithKeywords)pyebook_query_any_field_contains,
        METH_KEYWORDS | METH_VARARGS | METH_CLASS,
        "Replaces this query with a new 'generic' query."},
    {"_and",
        (PyCFunctionWithKeywords)pyebook_query_and,
        METH_KEYWORDS | METH_VARARGS,
        "Creates a new query with a 'and' operation with the given \
        query list and this query."},
     {"_or",
        (PyCFunctionWithKeywords)pyebook_query_or,
        METH_KEYWORDS | METH_VARARGS,
        "Creates a new querywith a 'or' operation with the given \
        query list and this query."},
     {"_not",
     (PyCFunction)pyebook_query_not,
        METH_NOARGS,
        "Creates a new query with a 'not' operation with this query."},
     {"copy",
     (PyCFunction)pyebook_query_copy,
        METH_NOARGS,
        "Copies this query."},
   {NULL}
};

PyTypeObject PyEBookQuery_Type = {
	PyObject_HEAD_INIT(NULL)
	0,                  /* ob_size */
	"ebook.EBookQuery",          /* tp_name */
	sizeof(PyEBookQuery),       /* tp_basicsize */
	0,                  /* tp_itemsize */
	/* methods */
	(destructor)pyebook_query_dealloc,   /* tp_dealloc */
	(printfunc)0,           /* tp_print */
	(getattrfunc)0,   /* tp_getattr */
	(setattrfunc)0,         /* tp_setattr */
	(cmpfunc)0,  /* tp_compare */
	(reprfunc)0,            /* tp_repr */
	0,                  /* tp_as_number */
	0,                  /* tp_as_sequence */
	0,                  /* tp_as_mapping */
	(hashfunc)0,    /* tp_hash */
	(ternaryfunc)0,         /* tp_call */
	pyebook_query_str,            /* tp_str */
	(getattrofunc)0,            /* tp_getattro */
	(setattrofunc)0,            /* tp_setattro */
	0,                  /* tp_as_buffer */
	Py_TPFLAGS_DEFAULT,         /* tp_flags */
	NULL, /* Documentation string */
	(traverseproc)0,            /* tp_traverse */
	(inquiry)0,             /* tp_clear */
	(richcmpfunc)0,         /* tp_richcompare */
	0,                  /* tp_weaklistoffset */
	(getiterfunc)0,         /* tp_iter */
	(iternextfunc)0,            /* tp_iternext */
	PyEBookQuery_methods,       /* tp_methods */
	0,                  /* tp_members */
	0,       /* tp_getset */
	(PyTypeObject *)0,          /* tp_base */
	(PyObject *)0,          /* tp_dict */
	0,                  /* tp_descr_get */
	0,                  /* tp_descr_set */
	0,                  /* tp_dictoffset */
	(initproc)0,            /* tp_init */
	(allocfunc)0,           /* tp_alloc */
	(newfunc)0,             /* tp_new */
	0,                  /* tp_free */
	(inquiry)0,             /* tp_is_gc */
	(PyObject *)0,          /* tp_bases */
};

static PyObject *
pyebook_query_new(EBookQuery *query)
{
	PyEBookQuery *self;

	self = (PyEBookQuery *)PyObject_NEW(PyEBookQuery, &PyEBookQuery_Type);

	if (self == NULL)
		return NULL;

	self->query = query;

	return (PyObject *)self;
}

static void
pyebook_query_dealloc(PyEBookQuery *self)
{
	if (self == NULL)
		return;

    if (self->query != NULL)
    	e_book_query_unref(self->query);
    PyObject_DEL(self);
}

static PyObject *
pyebook_query_str(PyEBookQuery *self){

    char *repr = NULL;
    PyObject *ret;

    if (self->query != NULL)
        repr = e_book_query_to_string(self->query);

    ret = PyString_FromString( repr != NULL ? repr : "<Uninitialized>");

    if (repr != NULL)
        free(repr);

    return ret;
}

static PyObject *
pyebook_query_from_string(PyEBookQuery *self,
                          PyObject *args,
                          PyObject *kwargs)
{
    static char *kwlist[] = { "query", NULL };
    char *query;
    EBookQuery *new_query;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s", kwlist, &query))
        return NULL;

    new_query = e_book_query_from_string(query);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_field_exists(PyEBookQuery *self,
                           PyObject *args,
                           PyObject *kwargs)
{
    static char *kwlist[] = { "field", NULL };
    PyObject *py_type;
    EContactField field;
    EBookQuery *new_query;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O", kwlist, &py_type))
        return NULL;

    if(pyg_enum_get_value(E_TYPE_CONTACT_FIELD, py_type, (gint *)&field))
        return NULL;

    new_query = e_book_query_field_exists(field);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_vcard_field_exists(PyEBookQuery *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
    static char *kwlist[] = { "field", NULL };
    char *field;
    EBookQuery *new_query;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s", kwlist, &field))
        return NULL;

    new_query = e_book_query_vcard_field_exists(field);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_field_test(PyEBookQuery *self,
                         PyObject *args,
                         PyObject *kwargs)
{
    static char *kwlist[] = { "field", "test", "value", NULL };
    PyObject *py_field;
    PyObject *py_test;
    EContactField field;
    EBookQueryTest test;
    char *value;
    EBookQuery *new_query;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OOs", kwlist,
                                     &py_field, &py_test, &value))
        return NULL;

    if(pyg_enum_get_value(E_TYPE_CONTACT_FIELD, py_field, (gint *)&field))
        return NULL;

    if(pyg_enum_get_value(E_TYPE_BOOK_QUERY_TEST, py_test, (gint *)&test))
        return NULL;

    new_query = e_book_query_field_test(field, test, value);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_any_field_contains(PyEBookQuery *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
    static char *kwlist[] = { "field", NULL };
    char *field;
    EBookQuery *new_query;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s", kwlist, &field))
        return NULL;

    new_query = e_book_query_any_field_contains(field);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_and(PyEBookQuery *self,
                  PyObject *args,
                  PyObject *kwargs)
{
    static char *kwlist[] = { "queries", NULL };
    PyObject *list;
    int size;
    int i;
    int has_self = 0;
    EBookQuery **queries = NULL;
    EBookQuery *new_query = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!", kwlist,
                                     &PyList_Type, &list))
        return NULL;

    size = PyList_Size(list);

    if (size == 0){
        Py_INCREF(Py_None);
        return Py_None;
    }

    if (self->query != NULL) {
        queries = (EBookQuery **)malloc(sizeof(EBookQuery *)*(size+1));
        queries[0] = self->query;
        has_self = 1;
    } else {
        queries = (EBookQuery **)malloc(sizeof(EBookQuery *)*(size));
    }

    for (i = 0; i < size; i++){
        PyEBookQuery *query;

        /* FIXME Check for EBookQuery type */
        query = (PyEBookQuery *) PyList_GetItem(list, i);

        queries[i+has_self] = query->query;
    }

    new_query = e_book_query_and(size+has_self, queries, FALSE);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_or(PyEBookQuery *self,
                 PyObject *args,
                 PyObject *kwargs)
{
    static char *kwlist[] = { "queries", NULL };
    PyObject *list;
    int size;
    int i;
    int has_self = 0;
    EBookQuery **queries = NULL;
    EBookQuery *new_query = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!", kwlist,
                                     &PyList_Type, &list))
        return NULL;

    size = PyList_Size(list);

    if (size == 0){
        Py_INCREF(Py_None);
        return Py_None;
    }

    if (self->query != NULL) {
        queries = (EBookQuery **)malloc(sizeof(EBookQuery *)*(size+1));
        queries[0] = self->query;
        has_self = 1;
    } else {
        queries = (EBookQuery **)malloc(sizeof(EBookQuery *)*(size));
    }

    for (i = 0; i < size; i++){
        PyEBookQuery *query;

        /* FIXME Check for EBookQuery type */
        query = (PyEBookQuery *) PyList_GetItem(list, i);

        queries[i+has_self] = query->query;
    }

    new_query = e_book_query_or(size+has_self, queries, FALSE);

    return pyebook_query_new(new_query);
}

static PyObject *
pyebook_query_not(PyEBookQuery *self,
                  PyObject *args)
{
    EBookQuery *new_query = NULL;

    if (self->query != NULL)
        new_query = e_book_query_not(self->query, FALSE);

    return pyebook_query_new(new_query);
}


static PyObject *
pyebook_query_copy(PyEBookQuery *self,
                   PyObject *args)
{
	return pyebook_query_new(e_book_query_copy(self->query));
}

/*** Types, helper functions and callbacks for EBookView ***/

/* Struct used to pack data passed to EBookView signals */
struct bookview_cb_t{
    PyObject *(*converter)(gpointer);
    PyObject *callback;
    PyObject *extra_data;
};

static PyObject *
glist_to_pylist(GList *list, PyObject *(*converter)(gpointer))
{
    PyObject *pylist;
    GList *node;
    int size;
    int i;

    size = g_list_length(list);
    pylist = PyList_New(size);
    node = list;

    for (i=0; i < size; i++){
        PyObject *pyobj;

        pyobj = converter(node->data);
        PyList_SetItem(pylist, i, pyobj);

        node = node->next;
    }

    return pylist;
}

PyObject *econtact_to_pycontact(EContact *contact)
{
    return pygobject_new(G_OBJECT(contact));
}

/* wrapper for callbacks that receive a GList as parameter */
static void
contacts_list_cb(EBookView *ebookview, GList *contacts, gpointer user_data)
{
    PyObject *list;
    PyObject *pybookview;
    PyObject *extra_args;
    PyObject *callback;
    PyObject *arguments;
    PyObject *result;
    struct bookview_cb_t *data;
    int i;
    int extra_size;

    pybookview = pygobject_new(ebookview);
    if (pybookview == NULL){
    }

    data = (struct bookview_cb_t*)user_data;

    callback = data->callback;
    extra_args = data->extra_data;

    list = glist_to_pylist(contacts, data->converter);

    if (extra_args != NULL){
        extra_size = PyTuple_Size(extra_args);
    } else {
        extra_size = 0;
    }

    arguments = PyTuple_New(extra_size+2);

    Py_INCREF(pybookview);
    PyTuple_SetItem(arguments, 0, pybookview);
    Py_INCREF(list);
    PyTuple_SetItem(arguments, 1, list);

    for (i = 2; i < extra_size+2; i++) {
        PyObject *obj;

        obj = PyTuple_GetItem(extra_args, i-2);
        Py_INCREF(obj);
        PyTuple_SetItem(arguments, i, obj);
    }

    result = PyObject_CallObject(callback, arguments);

    Py_XDECREF(result);
    Py_XDECREF(arguments);
    Py_XDECREF(pybookview);
    Py_XDECREF(list); /* Will decref its childs too? */

    return;
}

#line 527 "ebook.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject G_GNUC_INTERNAL PyEContact_Type;
PyTypeObject G_GNUC_INTERNAL PyEVCard_Type;
PyTypeObject G_GNUC_INTERNAL PyEBook_Type;
PyTypeObject G_GNUC_INTERNAL PyEBookView_Type;

#line 541 "ebook.c"



/* ----------- EVCard ----------- */

PyTypeObject G_GNUC_INTERNAL PyEVCard_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "ebook.EVCard",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)NULL, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- EContact ----------- */

#line 597 "ebook.override"
static int
_wrap_e_contact_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "vcard", NULL };
    gchar *vcard = NULL;
    EContact *contact = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|z:EContact.__init__",
                                     kwlist, &vcard))
        return -1;

    if (vcard)
        contact = (EContact *) e_contact_new_from_vcard(vcard);
    else
        contact = (EContact *) e_contact_new();

    if (!contact) {
        PyErr_SetString(PyExc_RuntimeError, "could not create EContact object");
        return -1;
    } else {
        self->obj = contact;
        return 0;
    }

}
#line 622 "ebook.c"


static PyObject *
_wrap_evo_contact_get_vcard_string(PyGObject *self)
{
    gchar *ret;

    
    ret = evo_contact_get_vcard_string(E_CONTACT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_evo_contact_get_name(PyGObject *self)
{
    gchar *ret;

    
    ret = evo_contact_get_name(E_CONTACT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_evo_contact_get_uid(PyGObject *self)
{
    gchar *ret;

    
    ret = evo_contact_get_uid(E_CONTACT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

#line 624 "ebook.override"
static PyObject *
_wrap_evo_contact_get_modified(PyGObject *self)
{
    EContact *contact = NULL;
    glong seconds = 0;
    char *timestr = NULL;
    struct tm *time = NULL;

    contact = E_CONTACT(self->obj);
    timestr = (char *)e_contact_get(contact, E_CONTACT_REV);

    if (timestr) {
        time = g_malloc0 (sizeof (struct tm));
        /* Evolution stores REV field in the following strftime format
        "%Y-%m-%dT%H:%M:%SZ" 
        Unparse it and reparse it to time since epoch
        */
        if (strptime(timestr, "%Y-%m-%dT%H:%M:%SZ", time)) {
            char seconds_string[25] = {0};

            strftime (seconds_string, sizeof(seconds_string), "%s", time);
            seconds = strtol(seconds_string, NULL, 10);
        }
    }

    g_free(time);
    g_free(timestr);

    return PyLong_FromLong((long) seconds);
}
#line 707 "ebook.c"


static PyObject *
_wrap_evo_contact_get_photo(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pixbuf_size", NULL };
    int pixbuf_size;
    GdkPixbuf *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:EContact.get_photo", kwlist, &pixbuf_size))
        return NULL;
    
    ret = evo_contact_get_photo(E_CONTACT(self->obj), pixbuf_size);
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static const PyMethodDef _PyEContact_methods[] = {
    { "get_vcard_string", (PyCFunction)_wrap_evo_contact_get_vcard_string, METH_NOARGS,
      NULL },
    { "get_name", (PyCFunction)_wrap_evo_contact_get_name, METH_NOARGS,
      NULL },
    { "get_uid", (PyCFunction)_wrap_evo_contact_get_uid, METH_NOARGS,
      NULL },
    { "get_modified", (PyCFunction)_wrap_evo_contact_get_modified, METH_NOARGS,
      NULL },
    { "get_photo", (PyCFunction)_wrap_evo_contact_get_photo, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyEContact_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "ebook.EContact",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyEContact_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_e_contact_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- EBook ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

#line 547 "ebook.override"
static PyObject*
_wrap_evo_addressbook_get_all_contacts(PyGObject *self) 
{
    GList *contacts = NULL;

    EBookQuery *query = e_book_query_any_field_contains("");
    e_book_get_contacts(E_BOOK(self->obj), query, &contacts, NULL);

    e_book_query_unref(query);

    return _helper_wrap_gobject_glist(contacts);
}
#line 812 "ebook.c"


static PyObject *
_wrap_evo_addressbook_get_contact(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uid", NULL };
    char *uid;
    EContact *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:EBook.get_contact", kwlist, &uid))
        return NULL;
    
    ret = evo_addressbook_get_contact(E_BOOK(self->obj), uid);
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 575 "ebook.override"
static PyObject *
_wrap_evo_addressbook_get_changed_contacts(PyGObject *self, PyObject *args)
{
    char *change_id = NULL;

    GList *added = NULL;
    GList *modified = NULL;
    GList *deleted = NULL;

    if (PyArg_ParseTuple(args, "s",&change_id)) {
        evo_addressbook_get_changed_contacts(E_BOOK(self->obj), &added, &modified, &deleted, change_id);
    }

    return Py_BuildValue("OOO",
                        _helper_wrap_gobject_glist(added),
                        _helper_wrap_gobject_glist(modified),
                        _helper_wrap_gobject_glist(deleted)
                        );
    
}
#line 852 "ebook.c"


#line 561 "ebook.override"
static PyObject*
_wrap_evo_addressbook_free_text_search(PyGObject *self, PyObject *args) 
{
    char *query = NULL;
    GList *list = NULL;

    if (PyArg_ParseTuple(args, "s",&query))
	{
        list = evo_addressbook_free_text_search(E_BOOK(self->obj), query);
	}
    return _helper_wrap_gobject_glist(list);
}
#line 868 "ebook.c"


static PyObject *
_wrap_e_book_remove(PyGObject *self)
{
    int ret;
    GError *error = NULL;

    
    ret = e_book_remove(E_BOOK(self->obj), &error);
    
    if (pyg_error_check(&error))
        return NULL;
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_evo_addressbook_remove_contact(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "contact", NULL };
    PyGObject *contact;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:EBook.remove_contact", kwlist, &PyEContact_Type, &contact))
        return NULL;
    
    ret = evo_addressbook_remove_contact(E_BOOK(self->obj), E_CONTACT(contact->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_e_book_remove_contact(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "id", NULL };
    char *id;
    int ret;
    GError *error = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:EBook.remove_contact_by_id", kwlist, &id))
        return NULL;
    
    ret = e_book_remove_contact(E_BOOK(self->obj), id, &error);
    
    if (pyg_error_check(&error))
        return NULL;
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_evo_addressbook_add_contact(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "contact", NULL };
    PyGObject *contact;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:EBook.add_contact", kwlist, &PyEContact_Type, &contact))
        return NULL;
    
    ret = evo_addressbook_add_contact(E_BOOK(self->obj), E_CONTACT(contact->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_evo_addressbook_contact_exists(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "contact", NULL };
    PyGObject *contact;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:EBook.contact_exists", kwlist, &PyEContact_Type, &contact))
        return NULL;
    
    ret = evo_addressbook_contact_exists(E_BOOK(self->obj), E_CONTACT(contact->obj));
    
    return PyBool_FromLong(ret);

}

#line 656 "ebook.override"
static PyObject *
_wrap_e_book_commit_contact(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = {"contact", NULL};
    PyGObject *pycontact;
    PyObject *pyret;
    EBook *book;
    EContact *contact;
    gboolean ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:EBook.commit_contact",
                                     kwlist, &PyEContact_Type,
                                     (PyObject **)&pycontact)){
        return NULL;
    }

    contact = (EContact *)pycontact->obj;
    book = (EBook *)self->obj;

    ret = e_book_commit_contact(book, contact, NULL);

    if (ret) {
        pyret = Py_True;
    } else {
        pyret = Py_False;
    }

    Py_XINCREF(pyret);
    return pyret;
}
#line 989 "ebook.c"


#line 688 "ebook.override"
static PyObject *
_wrap_e_book_get_book_view(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = {"query", "fields", "max", NULL};
    int results = 0;
    PyObject *pyfields = NULL;
    GList *fields = NULL;
    PyObject *query = NULL;
    PyObject *ret = NULL;
    int cret;
    EBookView *view = NULL;
    EBookQuery *equery = NULL;
    GError *err = NULL;

    if(!PyArg_ParseTupleAndKeywords(args, kwargs, "O!|O!i:EBook.get_book_view",
                                    kwlist, &PyEBookQuery_Type, &query, &PyList_Type, &pyfields,
                                    &results))
        return NULL;

    if (pyfields != NULL) {
        /* Translating to glist */
        int len;
        int i;

        len = PyList_Size(pyfields);

        for(i = 0; i < len; i++){
            PyObject *item;
            EContactField field;
            char *name;
            int size;

            item = PyList_GetItem(pyfields, i);

            pyg_enum_get_value(E_TYPE_CONTACT_FIELD, item, (gint *)&field);
            name = e_contact_field_name(field);
            fields = g_list_append(fields, name);
        }
    }

    equery = ((PyEBookQuery *)query)->query;
    cret = e_book_get_book_view(E_BOOK(self->obj), equery, fields, results, &view, &err);

    /* Create the bookview object */
    ret = pygobject_new(G_OBJECT(view));

    /* e_book_query_unref(equery); The book view gets the ownership of the ref */
    if (fields != NULL)
        g_list_free(fields);

    Py_XINCREF(ret);
    return ret;
}
#line 1046 "ebook.c"


static const PyMethodDef _PyEBook_methods[] = {
    { "get_all_contacts", (PyCFunction)_wrap_evo_addressbook_get_all_contacts, METH_NOARGS,
      NULL },
    { "get_contact", (PyCFunction)_wrap_evo_addressbook_get_contact, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_changed_contacts", (PyCFunction)_wrap_evo_addressbook_get_changed_contacts, METH_VARARGS,
      NULL },
    { "search", (PyCFunction)_wrap_evo_addressbook_free_text_search, METH_VARARGS,
      NULL },
    { "remove", (PyCFunction)_wrap_e_book_remove, METH_NOARGS,
      NULL },
    { "remove_contact", (PyCFunction)_wrap_evo_addressbook_remove_contact, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "remove_contact_by_id", (PyCFunction)_wrap_e_book_remove_contact, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "add_contact", (PyCFunction)_wrap_evo_addressbook_add_contact, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "contact_exists", (PyCFunction)_wrap_evo_addressbook_contact_exists, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "commit_contact", (PyCFunction)_wrap_e_book_commit_contact, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_book_view", (PyCFunction)_wrap_e_book_get_book_view, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyEBook_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "ebook.EBook",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyEBook_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- EBookView ----------- */

static PyObject *
_wrap_e_book_view_start(PyGObject *self)
{
    
    e_book_view_start(E_BOOK_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_e_book_view_stop(PyGObject *self)
{
    
    e_book_view_stop(E_BOOK_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 743 "ebook.override"
static PyObject *
_wrap_e_book_view_set_contacts_added_cb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    PyObject *callback;
    PyObject *extra_args;
    struct bookview_cb_t *data;
    int len;
    guint result;

    len = PyTuple_Size(args);
    if (len < 1){
        PyErr_SetString(PyExc_TypeError,
                        "EBookView.set_contacts_added_cb requires at least one argument");
        return NULL;
    }

    data = g_new(struct bookview_cb_t, 1);

    callback = PyTuple_GetItem(args, 0);

    if(!PyCallable_Check(callback)){
        PyErr_SetString(PyExc_TypeError, "callback must be callable");
        return NULL;
    }

    Py_XINCREF(callback);
    data->callback = callback;

    if (len > 1){
        extra_args = PySequence_GetSlice(args, 1, len);
    } else {
        extra_args = NULL;
    }

    data->extra_data = extra_args;
    data->converter = econtact_to_pycontact;

    result = g_signal_connect(self->obj, "contacts-added", contacts_list_cb, data);

    return PyInt_FromLong(result);
}
#line 1186 "ebook.c"


#line 786 "ebook.override"
static PyObject *
_wrap_e_book_view_remove_contacts_added_cb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] ={"handler_id", NULL};
    int handler;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i", kwlist, &handler)) {
        return NULL;
    }

    g_signal_handler_disconnect(self->obj, handler);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 1205 "ebook.c"


#line 803 "ebook.override"
static PyObject *
_wrap_e_book_view_set_contacts_changed_cb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    PyObject *callback;
    PyObject *extra_args;
    struct bookview_cb_t *data;
    int len;
    guint result;

    len = PyTuple_Size(args);
    if (len < 1){
        PyErr_SetString(PyExc_TypeError,
                        "EBookView.set_contacts_added_cb requires at least one argument");
        return NULL;
    }

    data = g_new(struct bookview_cb_t, 1);

    callback = PyTuple_GetItem(args, 0);

    if(!PyCallable_Check(callback)){
        PyErr_SetString(PyExc_TypeError, "callback must be callable");
        return NULL;
    }

    Py_XINCREF(callback);
    data->callback = callback;

    if (len > 1){
        extra_args = PySequence_GetSlice(args, 1, len);
    } else {
        extra_args = NULL;
    }

    data->extra_data = extra_args;
    data->converter = econtact_to_pycontact;

    result = g_signal_connect(self->obj, "contacts-changed", contacts_list_cb, data);

    return PyInt_FromLong(result);
}
#line 1250 "ebook.c"


#line 846 "ebook.override"
static PyObject *
_wrap_e_book_view_remove_contacts_changed_cb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] ={"handler_id", NULL};
    int handler;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i", kwlist, &handler)) {
        return NULL;
    }

    g_signal_handler_disconnect(self->obj, handler);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 1269 "ebook.c"


#line 863 "ebook.override"
static PyObject *
_wrap_e_book_view_set_contacts_removed_cb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    PyObject *callback;
    PyObject *extra_args;
    struct bookview_cb_t *data;
    int len;
    guint result;

    len = PyTuple_Size(args);
    if (len < 1){
        PyErr_SetString(PyExc_TypeError,
                        "EBookView.set_contacts_removed_cb requires at least one argument");
        return NULL;
    }

    data = g_new(struct bookview_cb_t, 1);

    callback = PyTuple_GetItem(args, 0);

    if(!PyCallable_Check(callback)){
        PyErr_SetString(PyExc_TypeError, "callback must be callable");
        return NULL;
    }

    Py_XINCREF(callback);
    data->callback = callback;

    if (len > 1){
        extra_args = PySequence_GetSlice(args, 1, len);
    } else {
        extra_args = NULL;
    }

    data->extra_data = extra_args;
    data->converter = PyString_FromString;

    result = g_signal_connect(self->obj, "contacts-removed", contacts_list_cb, data);

    return PyInt_FromLong(result);
}
#line 1314 "ebook.c"


#line 906 "ebook.override"
static PyObject *
_wrap_e_book_view_remove_contacts_removed_cb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] ={"handler_id", NULL};
    int handler;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i", kwlist, &handler)) {
        return NULL;
    }

    g_signal_handler_disconnect(self->obj, handler);

    Py_INCREF(Py_None);
    return Py_None;
}

#line 1334 "ebook.c"


static const PyMethodDef _PyEBookView_methods[] = {
    { "start", (PyCFunction)_wrap_e_book_view_start, METH_NOARGS,
      NULL },
    { "stop", (PyCFunction)_wrap_e_book_view_stop, METH_NOARGS,
      NULL },
    { "set_contacts_added_cb", (PyCFunction)_wrap_e_book_view_set_contacts_added_cb, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "remove_contacts_added_cb", (PyCFunction)_wrap_e_book_view_remove_contacts_added_cb, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_contacts_changed_cb", (PyCFunction)_wrap_e_book_view_set_contacts_changed_cb, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "remove_contacts_changed_cb", (PyCFunction)_wrap_e_book_view_remove_contacts_changed_cb, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_contacts_removed_cb", (PyCFunction)_wrap_e_book_view_set_contacts_removed_cb, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "remove_contacts_removed_cb", (PyCFunction)_wrap_e_book_view_remove_contacts_removed_cb, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyEBookView_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "ebook.EBookView",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyEBookView_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

#line 540 "ebook.override"
static PyObject*
_wrap_evo_environment_list_addressbooks(PyGObject *self) 
{
    return _helper_wrap_glist_of_evo_locations(evo_environment_list_addressbooks());
}
#line 1412 "ebook.c"


static PyObject *
_wrap_evo_environment_get_self_contact(PyObject *self)
{
    EContact *ret;

    
    ret = evo_environment_get_self_contact();
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_evo_addressbook_open(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uri", NULL };
    char *uri;
    EBook *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:open_addressbook", kwlist, &uri))
        return NULL;
    
    ret = evo_addressbook_open(uri);
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

const PyMethodDef pyebook_functions[] = {
    { "list_addressbooks", (PyCFunction)_wrap_evo_environment_list_addressbooks, METH_NOARGS,
      NULL },
    { "get_self_contact", (PyCFunction)_wrap_evo_environment_get_self_contact, METH_NOARGS,
      NULL },
    { "open_addressbook", (PyCFunction)_wrap_evo_addressbook_open, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pyebook_add_constants(PyObject *module, const gchar *strip_prefix)
{
  pyg_enum_add(module, "EContactField", strip_prefix, E_TYPE_CONTACT_FIELD);
  pyg_enum_add(module, "EBookQueryTest", strip_prefix, E_TYPE_BOOK_QUERY_TEST);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pyebook_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        _PyGObject_Type = (PyTypeObject *)PyObject_GetAttrString(module, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return ;
    }


#line 524 "ebook.override"
	PyEBookQuery_Type.tp_alloc = PyType_GenericAlloc;
	PyEBookQuery_Type.tp_new = PyType_GenericNew;
	if (PyType_Ready(&PyEBookQuery_Type) < 0)
		return;


#line 1493 "ebook.c"
    pygobject_register_class(d, "EVCard", E_TYPE_VCARD, &PyEVCard_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(E_TYPE_VCARD);
    pygobject_register_class(d, "EContact", E_TYPE_CONTACT, &PyEContact_Type, Py_BuildValue("(O)", &PyEVCard_Type));
    pygobject_register_class(d, "EBook", E_TYPE_BOOK, &PyEBook_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "EBookView", E_TYPE_BOOK_VIEW, &PyEBookView_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(E_TYPE_BOOK_VIEW);
}
